' ########################################################################################
' Creates an instance of a MCI control and opens a .wav file.
' ########################################################################################

' SED_PBWIN - Use the PBWIN compiler
#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "OLECON.INC"
#INCLUDE ONCE "MCI32.INC"

%IDC_MCI = 1001

' ========================================================================================
' Main
' ========================================================================================
FUNCTION PBMAIN

   LOCAL hDlg AS DWORD

   OC_WinInit ' // Initialize the Ole Container

   DIALOG NEW 0, "Multimedia MCI Control Example",,, 258, 30, %WS_OVERLAPPEDWINDOW, 0 TO hDlg
   DIALOG SHOW MODELESS hDlg, CALL MainDlgProc

   ' Message handler loop
   LOCAL uMsg AS tagMsg
   WHILE GetMessage(uMsg, %NULL, 0, 0)
'      IF ISFALSE OC_ForwardMessage(GetFocus, uMsg) THEN
         IF IsDialogMessage(hDlg, uMsg) = 0 THEN
            TranslateMessage uMsg
            DispatchMessage uMsg
'         END IF
      END IF
   WEND

END FUNCTION
' ========================================================================================

' ========================================================================================
' Main dialog callback
' ========================================================================================
CALLBACK FUNCTION MainDlgProc()

   LOCAL  hMci AS DWORD
   LOCAL  pMci AS Imci
   LOCAL  hCtl AS DWORD
   LOCAL  rc   AS RECT
   LOCAL  cp   AS OC_CREATEPARAMS
   STATIC pMciEvents AS DmciEventsImpl

   SELECT CASE CB.MSG

      CASE %WM_INITDIALOG
         ' Create an instance of the MMControl
         GetClientRect CB.HNDL, rc
         cp.clsid = $CLSID_MMControl
         cp.riid = $IID_Imci
         cp.szLicKey = $RTLKEY_MMControl
         cp.szLibName = EXE.Path$ & "mci32.ocx"
         hCtl = CreateWindowEx(0, $OC_CLASSNAME, "", _
            %WS_CHILD OR %WS_VISIBLE OR %WS_BORDER OR %WS_TABSTOP, _
            0, 0, rc.nRight - rc.nLeft, rc.nBottom - rc.nTop, _
            CB.HNDL, %IDC_MCI, GetModuleHandle(BYVAL %NULL), cp)

         ' Get a reference to the Imci interface
         pMci = OC_GetDispatch(hCtl)
         ' Set properties needed by MCI to open
         IF ISOBJECT(pMci) THEN
            ' Connect to the events fired by the control
            pMciEvents = CLASS "CDmciEvents"
            EVENTS FROM pMci CALL pMciEvents
            ' Set properties needed by MCI to open
            pMci.Notify = %VARIANT_FALSE
            pMci.Wait = %VARIANT_TRUE
            pMci.Shareable = %VARIANT_FALSE
            pMci.DeviceType = UCODE$("WaveAudio")
            pMci.FileName = UCODE$("C:\WINDOWS\MEDIA\TADA.WAV")  ' --> change as needed
            ' Open the MCI WaveAudio device.
            pMci.Command = UCODE$("Open")
         END IF

      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDCANCEL
               IF CB.CTLMSG = %BN_CLICKED THEN DIALOG END CB.HNDL, 0
         END SELECT

      CASE %WM_SYSCOMMAND
         ' Capture this message and send a %WM_CLOSE message.
         IF (CB.WPARAM AND &HFFF0) = %SC_CLOSE THEN
            DIALOG SEND CB.HNDL, %WM_CLOSE, 0, 0
            EXIT FUNCTION
         END IF

      CASE %WM_DESTROY
         ' Get a reference to the Imci interface
         pMci = OC_GetDispatch(hCtl)
         IF ISOBJECT(pMci) THEN
            ' Close MCI
            pMci.Command = UCODE$("Close")
            pMci = NOTHING
         END IF
         ' Disconnect events and quit
         IF ISOBJECT(pMciEvents) THEN EVENTS END pMciEvents
         PostQuitMessage 0

   END SELECT

END FUNCTION
' ========================================================================================



' ########################################################################################
' Class CDmciEvents
' Interface name = DmciEvents
' IID = {C1A8AF27-1257-101B-8FB0-0020AF039CA3}
' Event interface for MCI Control
' Attributes = 4224 [&H1080] [Nonextensible] [Dispatchable]
' Code generated by the TypeLib Browser 4.0.13 (c) 2008 by Jos Roca
' Date: 18 dic 2008   Time: 00:05:45
' ########################################################################################

CLASS CDmciEvents GUID$("{738E225D-DA6F-4829-A9D0-C5B78934578A}") AS EVENT

INTERFACE DmciEventsImpl GUID$("{C1A8AF27-1257-101B-8FB0-0020AF039CA3}") AS EVENT

  INHERIT IDispatch

   ' =====================================================================================
   METHOD Done <38> ( _
     BYREF NotifyCode AS INTEGER _                      ' *NotifyCode VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD BackClick <1> ( _
     BYREF iCancel AS INTEGER _                         ' *Cancel VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PrevClick <2> ( _
     BYREF iCancel AS INTEGER _                         ' *Cancel VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD NextClick <3> ( _
     BYREF iCancel AS INTEGER _                         ' *Cancel VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PlayClick <4> ( _
     BYREF iCancel AS INTEGER _                         ' *Cancel VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PauseClick <5> ( _
     BYREF iCancel AS INTEGER _                         ' *Cancel VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD StepClick <6> ( _
     BYREF iCancel AS INTEGER _                         ' *Cancel VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD StopClick <7> ( _
     BYREF iCancel AS INTEGER _                         ' *Cancel VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD RecordClick <8> ( _
     BYREF iCancel AS INTEGER _                         ' *Cancel VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD EjectClick <9> ( _
     BYREF iCancel AS INTEGER _                         ' *Cancel VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PrevGotFocus <10>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PrevLostFocus <11>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD NextGotFocus <12>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD NextLostFocus <13>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PlayGotFocus <14>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PlayLostFocus <15>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PauseGotFocus <16>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PauseLostFocus <17>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD BackGotFocus <18>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD BackLostFocus <19>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD StepGotFocus <20>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD StepLostFocus <21>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD StopLostFocus <22>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD StopGotFocus <23>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD RecordGotFocus <24>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD RecordLostFocus <25>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD EjectGotFocus <26>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD EjectLostFocus <27>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD StatusUpdate <28>

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD NextCompleted <29> ( _
     BYREF Errorcode AS LONG _                          ' *Errorcode VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PlayCompleted <30> ( _
     BYREF Errorcode AS LONG _                          ' *Errorcode VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PauseCompleted <31> ( _
     BYREF Errorcode AS LONG _                          ' *Errorcode VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD BackCompleted <32> ( _
     BYREF Errorcode AS LONG _                          ' *Errorcode VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD StepCompleted <33> ( _
     BYREF Errorcode AS LONG _                          ' *Errorcode VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD StopCompleted <34> ( _
     BYREF Errorcode AS LONG _                          ' *Errorcode VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD RecordCompleted <35> ( _
     BYREF Errorcode AS LONG _                          ' *Errorcode VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD EjectCompleted <36> ( _
     BYREF Errorcode AS LONG _                          ' *Errorcode VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD PrevCompleted <37> ( _
     BYREF Errorcode AS LONG _                          ' *Errorcode VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OLEStartDrag <1550> ( _
     BYREF pData AS IDispatch _                         ' [in][out] **Data DataObject <coclass>
   , BYREF AllowedEffects AS LONG _                     ' [in][out] *AllowedEffects VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OLEGiveFeedback <1551> ( _
     BYREF Effect AS LONG _                             ' [in][out] *Effect VT_I4 <Long>
   , BYREF DefaultCursors AS INTEGER _                  ' [in][out] *DefaultCursors VT_BOOL <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OLESetData <1552> ( _
     BYREF pData AS IDispatch _                         ' [in][out] **Data DataObject <coclass>
   , BYREF DataFormat AS INTEGER _                      ' [in][out] *DataFormat VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OLECompleteDrag <1553> ( _
     BYREF Effect AS LONG _                             ' [in][out] *Effect VT_I4 <Long>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OLEDragOver <1554> ( _
     BYREF pData AS IDispatch _                         ' [in][out] **Data DataObject <coclass>
   , BYREF Effect AS LONG _                             ' [in][out] *Effect VT_I4 <Long>
   , BYREF iButton AS INTEGER _                         ' [in][out] *Button VT_I2 <Integer>
   , BYREF iShift AS INTEGER _                          ' [in][out] *Shift VT_I2 <Integer>
   , BYREF X AS SINGLE _                                ' [in][out] *X VT_R4 <Single>
   , BYREF Y AS SINGLE _                                ' [in][out] *Y VT_R4 <Single>
   , BYREF iState AS INTEGER _                          ' [in][out] *State VT_I2 <Integer>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

   ' =====================================================================================
   METHOD OLEDragDrop <1555> ( _
     BYREF pData AS IDispatch _                         ' [in][out] **Data DataObject <coclass>
   , BYREF Effect AS LONG _                             ' [in][out] *Effect VT_I4 <Long>
   , BYREF iButton AS INTEGER _                         ' [in][out] *Button VT_I2 <Integer>
   , BYREF iShift AS INTEGER _                          ' [in][out] *Shift VT_I2 <Integer>
   , BYREF X AS SINGLE _                                ' [in][out] *X VT_R4 <Single>
   , BYREF Y AS SINGLE _                                ' [in][out] *Y VT_R4 <Single>
   )                                                    ' void

     ' *** Insert your code here ***
     OutputDebugString FUNCNAME$

   END METHOD
   ' =====================================================================================

END INTERFACE

END CLASS
